
QGIS Application - Bug report #18981

Save QLR crashes QGIS 3

2018-05-18 11:29 AM - Jakob Lanstorp

Status: Closed

Priority: High

Assignee: Alessandro Pasotti

Category: Unknown

Affected QGIS version:3.0.2 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:Yes Resolution: fixed/implemented

Crashes QGIS or corrupts data:Yes Copied to github as #: 26812

Description

When saving a QLR file having many grouped WMS in TOC 3.0.2-Girona crashes

Attached image of TOC where the parent group called qgis_plugin is saved as a QLR. QLR file also attached.

Crash report:

h2. User Feedback

h2. Report Details

Crash ID: e1167528848bf019c0d2ca12d580a5988469a23b

Stack Trace

QgsMapLayer::writeLayerXml :

QgsLayerDefinition::exportLayerDefinition :

QgsLayerDefinition::exportLayerDefinition :

QgisApp::saveAsLayerDefinition :

QgisApp::qt_static_metacall :

QMetaObject::activate :

QAction::activate :

QMenu::actionGeometry :

QMenu::actionGeometry :

QMenu::mouseReleaseEvent :

QWidget::event :

QMenu::event :

QApplicationPrivate::notify_helper :

QApplication::notify :

QgsApplication::notify :

QCoreApplication::notifyInternal2 :

QApplicationPrivate::sendMouseEvent :

QSizePolicy::QSizePolicy :

QSizePolicy::QSizePolicy :

QApplicationPrivate::notify_helper :

QApplication::notify :

QgsApplication::notify :

QCoreApplication::notifyInternal2 :

QGuiApplicationPrivate::processMouseEvent :

QWindowSystemInterface::sendWindowSystemEvents :

QEventDispatcherWin32::processEvents :

CallWindowProcW :

DispatchMessageW :
QEventDispatcherWin32::processEvents :

qt_plugin_query_metadata :

QEventLoop::exec :

QMenu::exec :

QgsLayerTreeView::contextMenuEvent :

QWidget::event :

QFrame::event :

QAbstractItemView::viewportEvent :

QCoreApplicationPrivate::sendThroughObjectEventFilters :

QApplicationPrivate::notify_helper :

QApplication::notify :

QgsApplication::notify :

QCoreApplication::notifyInternal2 :

QSizePolicy::QSizePolicy :

QSizePolicy::QSizePolicy :

QApplicationPrivate::notify_helper :

QApplication::notify :

QgsApplication::notify :

QCoreApplication::notifyInternal2 :

QGuiApplicationPrivate::processMouseEvent :

QWindowSystemInterface::sendWindowSystemEvents :

QEventDispatcherWin32::processEvents :

CallWindowProcW :

DispatchMessageW :

QEventDispatcherWin32::processEvents :

qt_plugin_query_metadata :

QEventLoop::exec :

QCoreApplication::exec :

main :

BaseThreadInitThunk :

RtlUserThreadStart :

QGIS Info

QGIS Version: 3.0.2-Girona

QGIS code revision: commit:307d082e3d

Compiled against Qt: 5.9.2

Running against Qt: 5.9.2

Compiled against GDAL: 2.2.4

Running against GDAL: 2.2.4

System Info

CPU Type: x86_64

Kernel Type: winnt

Kernel Version: 10.0.16299

Associated revisions

Revision ec909b0a - 2018-06-06 05:57 PM - Alessandro Pasotti 

[bugfix] Crash when exporting (invalid) legend to qlr
Fixes #18981 Save QLR crashes QGIS 3

This patch definitely prevents the crash but I'm not sure if

we should also introduce the same check in QgsLayerTree::isLayer

or even in QgsLayerTreeGroup::findLayers() or also when importing

a qlr that might lead to invalid layer (like in this

bug report).

Revision 51ae8e9e - 2018-06-07 09:55 AM - Alessandro Pasotti 

Merge pull request #7195 from elpaso/bugfix-18981-export-qlr-crash-2

[bugfix] Crash when exporting (invalid) legend to qlr

Fixes #18981

History

#1 - 2018-06-04 05:32 PM - Alessandro Pasotti

- Status changed from Open to Feedback

- Assignee set to Alessandro Pasotti

I'm not able to reproduce this issue, can you please attach a minimal project and step-by-step procedure to reproduce it?

#2 - 2018-06-06 11:29 AM - Jakob Lanstorp

Download the attached qlr file called kortforsyning_data.qlr (content is only WMS layers). Open it in QGIS and try to save it as a new QLR file.

#3 - 2018-06-06 05:16 PM - Alessandro Pasotti

- Priority changed from Normal to High

- Status changed from Feedback to In Progress

Confirmed, working on it

#4 - 2018-06-06 05:59 PM - Alessandro Pasotti

- Pull Request or Patch supplied changed from No to Yes

PR https://github.com/qgis/QGIS/pull/7195

#5 - 2018-06-06 06:01 PM - Alessandro Pasotti

for the record: the invalid layer was DTK/D850 but still QGIS does not need to crash.

#6 - 2018-06-07 09:55 AM - Anonymous

- % Done changed from 0 to 100
- Status changed from In Progress to Closed

Applied in changeset commit:qgis|ec909b0aabb9ed66050130672b19af1c9c1f5338.

#7 - 2018-06-07 09:55 AM - Alessandro Pasotti

- Resolution set to fixed/implemented

Files

Udklip.PNG 25.1 KB 2018-05-18 Jakob Lanstorp

kortforsyning_data.qlr 263 KB 2018-05-18 Jakob Lanstorp
